import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.List;
import greenfoot.MouseInfo.*;
/**
 * A crosshair is used to shoot ducks.
 * 
 * @author Eunice Leung
 */
public class Crosshair extends Actor
{
    
    /**
     * Make the crosshair follow the mouse and check for mouseclicks.
     */
    public void act() 
    {
        // Follow the mouse
        if(Greenfoot.mouseMoved(null)) 
        {
            MouseInfo mouse = Greenfoot.getMouseInfo();
            setLocation(mouse.getX(), mouse.getY());
        }
        
        // Pop
        if(Greenfoot.mouseClicked(null))
        {   
            Greenfoot.playSound("Shotgun Distant2.wav");
            
            List<Duck> ducks = getObjectsInRange(15, Duck.class);
            if (ducks.size() != 0) 
            {
                Duck duck = ducks.get(0);
                duck.pop();
            }
            List<WipeOut> wipeouts = getObjectsInRange(15, WipeOut.class);
            if (wipeouts.size() != 0)
            {
                WipeOut wipeout = wipeouts.get(0);
                wipeout.wipe();
            }
           
         }
     }   
}




