import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * A Duck flows from bottom to top.
 * 
 * @author Poul Henriksen
 */
public class Duck extends Actor
{
    private GreenfootImage image1;
    private GreenfootImage image2;
    int a = Greenfoot.getRandomNumber(20);
    LevelInt levelint = new LevelInt("Level: ");
    boolean flyingUp = true;
   public Duck()
   {
        image1 = new GreenfootImage("duckdown.png");
        image2 = new GreenfootImage("duckup.png");
        setImage(image1);
   }
    
    /**
     * Make the duck go sideways. 
     */ 
    public void act() 
    {
        switchImage();
        /**
         * Level 1.
         */
        if ( LevelInt.value == 1)
        {
            flyAcross();
        }
        /**
         * Level 2 and 3.
         */
        if (LevelInt.value == 2 || LevelInt.value == 3)
        {
            flyRandomly();
        }
        //remove duck when at right border
        if(getX() == 799)
        {
            getWorld().removeObject(this);
        }
        /**
         * Losing or Winning.
         */
        if ( LevelInt.value == 1 || LevelInt.value == 2)//Level 1 or 2
        {        
            if (((DuckWorld) getWorld()).ducksSeen == 12 && ShotCounter.target < 7) 
            {
                ((DuckWorld) getWorld()).gameOver();
                Greenfoot.stop();
            }
            if (((DuckWorld) getWorld()).ducksSeen == 12 && ShotCounter.target >= 7) 
            {
                ((DuckWorld) getWorld()).nextLevel();
            }
        }
        else if (LevelInt.value == 3)//Level 3
        {
            if (((DuckWorld) getWorld()).ducksSeen == 18 && ShotCounter.target < 16) 
            {
                ((DuckWorld) getWorld()).gameOver();
                Greenfoot.stop();
            }
            if (((DuckWorld) getWorld()).ducksSeen == 18 && ShotCounter.target >= 16) 
            {
                ((DuckWorld) getWorld()).nextLevel();
            }
        }
        
    }    
    
    /**
     * Fly up and right.
     */
    public void flyUpRight()
    {
        setLocation (getX() + 2, getY() - 2);
        flyingUp = true;
    }
    
    /**
     * Fly down and right.
     */
    public void flyDownRight()
    {
        setLocation (getX() + 2, getY() + 2);
        flyingUp = false;
    }
    
    /**
     * Change directions.
     */
    public void changeDirections()
    {
        if ( flyingUp )
        {
            flyDownRight();
        }
        else
        {
            flyUpRight();
        }
    }
    
    /**
     * Don't change directions.
     */
    public void keepFlying()
    {
        if (flyingUp)
        {
            flyUpRight();
        }
        else
        {
            flyDownRight();
        }
    }
    
    /**
     * Random flying movements.
     */
    public void flyRandomly()
    {
        //border check
        if (getY() <= 30)
        {
            flyDownRight();
        }
        else if (getY() >= 427)
        {
            flyUpRight();
        }
        else if(Greenfoot.getRandomNumber(100) <= 1)//Random Movement
        {
            changeDirections();
        }
        else
        {
         keepFlying();   
        }
    }
    /**
     * Fly horizontally
     */
    public void flyAcross()
    {
        setLocation(getX() + 2, getY());
    }
    
    /**
     * Pop this duck.
     */
    public void pop() 
    {
        Greenfoot.playSound("Duck quack 5.wav");
        ((DuckWorld) getWorld()).countPop();
        ((DuckWorld) getWorld()).countShot();
        getWorld().removeObject(this);
        
    }
    
    /**
     * Alternate the duck's image between image1 and image2.
     */
    public void switchImage()
    {
        if (a == 1)
        {
            if (getImage() == image1) 
            {
                setImage(image2);
            }
            else
            {
                setImage(image1);
            }
        }
        a++;
        if (a == 20)
        {
            a = 1;
        }
    }
}
